Subject: Re: speed of git reset -- file

From: Joey Hess <[email-masked]>
Date: Wed, 1 Jun 2011 19:31:57 -0400

Jeff King wrote:
> OK, that's horrific. For me, the stat information for linux-2.6 all sits
> in cache and it takes about 0.3 seconds to refresh the index. I have 8G
> of ram and a nice SSD, though it doesn't actually hit the disk at all.
> 
> Is it really faulting the stat information from disk that takes so long?
> Have you tried running "perf" on "git update-index --refresh"?

Cold cache:

 Performance counter stats for 'git update-index --refresh':

       9725.574501 task-clock-msecs         #      0.337 CPUs 
            58,163 context-switches         #      0.006 M/sec
                94 CPU-migrations           #      0.000 M/sec
             8,637 page-faults              #      0.001 M/sec
    12,825,956,531 cycles                   #   1318.787 M/sec  (scaled from 33.43%)
     2,696,089,912 instructions             #      0.210 IPC    (scaled from 50.03%)
       457,705,110 branches                 #     47.062 M/sec  (scaled from 51.30%)
        40,033,685 branch-misses            #      8.747 %      (scaled from 50.19%)
       149,071,234 cache-references         #     15.328 M/sec  (scaled from 32.83%)
         9,662,661 cache-misses             #      0.994 M/sec  (scaled from 32.27%)

       28.846625099  seconds time elapsed

Warm cache is 0.88 seconds, but cold cache is typical; I use a cheap netbook
for a lot of different stuff.

Also, I can get much worse cold cache numbers on eg, a fairly average
VPS node, where it takes > 1 minute.

-- 
see shy jo